// kmap.cpp

#include	"kmap.h"

#define	VER	"kmap ver.0.01"
#define	CRT	"2000.6.16"

int main()
{
	kmap	app;
	app.Run();
}

void quit(char *p)
{
	if(*p)printf("error : %s\n",p);
	else printf("complete\n");
	exit(0);
}
//------------------------------------------------
kmap::kmap():BApplication("application/x-vnd.Beer-kmap")
{
	BDirectory	dir;
	app_info	inf;
	be_app->GetAppInfo(&inf);
	BEntry	appent(&(inf.ref));
	BEntry	dirent;
	appent.GetParent(&dirent);
	BPath	dirpath;
	dirent.GetPath(&dirpath);

	char	fn[256];
	FILE	*fp;
	uchar	s[256];
	sprintf(fn,"%s/%s",dirpath.Path(),"kmap.dat");
	if((fp=fopen(fn,"r"))==NULL)quit("cannot open < kmap.dat >");
	char	d=0;
	uint32	n=0;
	dat[0].no=0;dat[0].sc=-1;dat[0].ec=-1;strcpy(dat[0].s,"top");
	for(int i=1;fgets((char*)s,256,fp);){
		uchar	*sp;
		for(sp=s+strlen((char*)s)-1;*sp<0x20;sp--)*sp=0;
		for(sp=s;*sp<0x20;sp++);
		if(*sp=='!'){
			if(!strcmp((char*)sp,"end")){
				dat[i].s[0]=0;
				break;
			}
		}else if(*sp=='}'){
			d--;
			n&=~((1<<(24-d*8))-1);
		}else{
			n+=1<<(24-d*8);
			dat[i].no=n;
			strcpy(dat[i].s,(char*)sp);
			sp=(uchar*)dat[i].s+strlen(dat[i].s)-1;
			if(*sp=='{'){
				dat[i].sc=-1;
				dat[i].ec=-1;
				n&=~((1<<(24-d*8))-1);
				d++;
			}else{
//				sscanf(sp-8,"%x,%x",&(dat[i].sc),&(dat[i].ec));
				uint32	sc,ec;
				sscanf((char*)sp-8,"%x,%x",&sc,&ec);
				dat[i].sc=sc;dat[i].ec=ec;
				sp-=9;
			}
			*(sp--)=0;while(*sp<0x20)*(sp--)=0;
			i++;
		}
	}
	fclose(fp);
//for(int i=0;dat[i].s[0];i++)printf("i=%04x no=%08x sc=%04x ec=%04x [%s]\n",i,dat[i].no,dat[i].sc,dat[i].ec,dat[i].s);

	BRect	frame(50,50,250,250);
	w=new kmapwindow(frame);
}

void kmap::AboutRequested()
{ 
	BAlert *alert;
	alert=new BAlert("",
		VER"  "CRT"\n"
		"    copyright Hiroyuki Tsutsumi\n\n"
		" E-mail : hirotsu@blue.plala.or.jp\n"
		"   HP   : http://www1.plala.or.jp/hirotsu/"
	,"Thank you");
	alert->Go();
} 
//------------------------------------------------
kmapwindow::kmapwindow(BRect frame):BWindow(frame,VER,B_DOCUMENT_WINDOW,0)
{
	sbv=sbh=NULL;sv=NULL;
	BRect	viewframe;
	viewframe.Set(0,0,frame.Width()-B_V_SCROLL_BAR_WIDTH,frame.Height()-B_H_SCROLL_BAR_HEIGHT-20);
	viewframe.OffsetTo(0,20);
	v=new kmapview(viewframe);
	AddChild(v);
	setupmenus();
	BRect	sbvframe;
	sbvframe.Set(0,0,B_V_SCROLL_BAR_WIDTH,viewframe.Height());
	sbvframe.OffsetTo(viewframe.Width()+1,20);
	sbv=new BScrollBar(sbvframe,"scrollv",(BView*)v,0,0,B_VERTICAL);
	AddChild(sbv);
	BRect	sbhframe;
	sbhframe.Set(0,0,viewframe.Width()-80,B_H_SCROLL_BAR_HEIGHT);
	sbhframe.OffsetTo(80,viewframe.Height()+21);
	sbh=new BScrollBar(sbhframe,"scrollh",(BView*)v,0,0,B_HORIZONTAL);
	AddChild(sbh);
	BRect	svframe;
	svframe.Set(0,0,80,B_H_SCROLL_BAR_HEIGHT);
	svframe.OffsetTo(0,viewframe.Height()+21);
	sv=new BStringView(svframe,"message","");
	sv->SetViewColor(200,200,200);
	sv->SetLowColor(160,160,160);
	AddChild(sv);
	Show();
}

bool kmapwindow::QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);
	return(true);
}

void kmapwindow::FrameResized(float width,float height)
{
	if(sv)sv->MoveTo(0,height-B_H_SCROLL_BAR_HEIGHT+1);
	adjustsb();
}

void kmapwindow::setupmenus()
{
	BMenuBar	*mb;
	BMenu		*m,*mm;
	BMenuItem	*mi;
	BMessage	*mes;
	mb=new BMenuBar(BRect(0,0,20,20),"menubar");
	m=new BMenu("File");
	 mi=new BMenuItem("about",new BMessage(B_ABOUT_REQUESTED));
	 mi->SetTarget((BHandler*)be_app);
	 m->AddItem(mi);
	 mi=new BMenuItem("quit",new BMessage(B_QUIT_REQUESTED));
	 mi->SetTarget((BHandler*)be_app);
	 m->AddItem(mi);
	mb->AddItem(m);
	AddChild(mb);
	
	m=new BMenu("Font");
	int	nf=count_font_families();
	for(int i=0;i<nf;i++){
		font_family	ff;
		uint32	f;
		if(get_font_family(i,&ff,&f)==0){
			mm=new BMenu(ff);
			int	ns=count_font_styles(ff);
			for(int j=0;j<ns;j++){
				font_style	fs;
				if(get_font_style(ff,j,&fs,&f)==0){
					mes=new BMessage('font');
					mes->AddString("font_family",ff);
					mes->AddString("font_style",fs);
					mi=new BMenuItem(fs,mes);
					mi->SetTarget((BHandler*)v);
					mm->AddItem(mi);
				}
			}
			m->AddItem(mm);
		}
	}
	mb->AddItem(m);

	m=new BMenu("Size");
	for(int i=10;i<=40;i+=2){
		char	s[4];
		sprintf(s,"%d",i);
		mes=new BMessage('font');
		mes->AddInt8("font_size",(int8)i);
		mi=new BMenuItem(s,mes);
		mi->SetTarget((BHandler*)v);
		m->AddItem(mi);
	}
	mb->AddItem(m);
}

void kmapwindow::adjustsb()
{
	int	rv,rh;
	rv=vh-sbv->Bounds().Height();
	rh=vw-sbh->Bounds().Width()-sv->Bounds().Width();
	sbv->SetRange(0,rv>0?rv:0);
	sbh->SetRange(0,rh>0?rh:0);
}

void kmapwindow::viewresized()
{
	int	ww,wh;
	ww=vw+B_V_SCROLL_BAR_WIDTH;
	wh=vh+B_H_SCROLL_BAR_HEIGHT+20;
	SetZoomLimits(ww,wh);
	adjustsb();
}
//------------------------------------------------
kmapview::kmapview(BRect frame):BView(frame,"kmapview",B_FOLLOW_ALL_SIDES,B_WILL_DRAW|B_PULSE_NEEDED)
{
	mp=18;
	mf.SetFamilyAndStyle("Haru","Bold");
	mf.SetSize(mp);
	cp=20;
	cf.SetFamilyAndStyle("Haru","Regular");
	cf.SetSize(cp);
	sel=0;
}

void kmapview::AttachedToWindow()
{
	SetHighColor(0,0,0);
	SetViewColor(255,255,245);
	SetLowColor(200,200,180);
//	SetViewColor(245,255,245);
//	SetLowColor(180,200,180);
}

void kmapview::Draw(BRect rect)
{
	SetFont(&mf);

	int	x,y,depth;
	depth=0;
	x=0;	y=0;
	SetHighColor(0,0,150);	SetLowColor(200,200,230);
	for(int i=0;i<sel;i++){
		if((dat[sel].no&(~(0xffffffff>>(depth*8))))==dat[i].no){
			DrawString(dat[i].s,BPoint(0,y+mp));
			y+=mp;
			depth++;
		}
	}
	SetHighColor(180,0,0);	SetLowColor(240,200,180);
	DrawString(dat[sel].s,BPoint(0,y+mp));
	y+=mp;

	SetHighColor(0,0,0);	SetLowColor(200,200,180);
	if(dat[sel].sc==0xffff){
		int	no=dat[sel].no;
		for(int i=sel+1;dat[i].s[0];i++){
			if(dat[i].no>no+(0xffffffff>>(depth*8)))break;		//after select-area
			if(dat[i].no&(0x00ffffff>>(depth*8)))continue;		//skip sub-menu
			DrawString(dat[i].s,BPoint(0,y+mp));
			y+=mp;
		}
		vw=200;vh=y;
	}else{
		SetFont(&cf);
		font_height	fh;
		cf.GetHeight(&fh);
		y+=5;
		cx=0;cy=y;cw=cp+2;ch=fh.ascent+fh.descent+2;
		uint16	oc=dat[sel].sc&0xfff0;
		uint16	cs=((dat[sel].ec+15)&0xfff0)-oc;
		for(int iy=0;iy<cs/16;iy++){
			x=cx;
			for(int ix=0;ix<16;ix++){
				uint16	c=oc+iy*16+ix;
				if((c>=dat[sel].sc)&&(c<=dat[sel].ec)){
					StrokeRect(BRect(x,y,x+cw-1,y+ch-1));
					char	s[2],t[8];
					int32	sl,tl,st;
					s[0]=c>>8;	s[1]=c&255;	sl=2;	tl=8;
					convert_to_utf8(B_UNICODE_CONVERSION,s,&sl,t,&tl,&st);
					DrawString(t,tl,BPoint(x+1,y+fh.ascent));
				}else{
					FillRect(BRect(x,y,x+cw-1,y+ch-1));
				}
				x+=cw;
			}
			y+=ch;
		}
		vw=cx+cw*16;vh=y;
	}
	((kmapwindow*)Window())->viewresized();
}

void kmapview::MouseDown(BPoint pt)
{
	int		x,y;
	int		no=dat[sel].no;
	int		depth=0;
	x=pt.x;	y=pt.y;
	for(int i=0;i<sel;i++){
		if((dat[sel].no&(~(0xffffffff>>(depth*8))))==dat[i].no){
			y-=mp;
			depth++;
			if(y<0){
				sel=i;
				Invalidate();
				return;
			}
		}
	}
	y-=mp;
	if(y<0)return;

	if(dat[sel].sc==0xffff){
		int	depth;
		for(depth=0;no&(0xff000000>>(depth*8));depth++);
		for(int i=sel+1;dat[i].s[0];i++){
			if(dat[i].no>no+(0xffffffff>>(depth*8)))break;		//after select-area
			if(dat[i].no&(0x00ffffff>>(depth*8)))continue;		//skip sub-menu
			y-=mp;
			if(y<0){
				sel=i;
				Invalidate();
				return;
			}
		}
	}else{
		x=(pt.x-cx)/cw;	y=(pt.y-cy)/ch;
		uint16	c=(dat[sel].sc&0xfff0)+y*16+x;
		if((c>=dat[sel].sc)&&(c<=dat[sel].ec)&&(x>=0)&&(x<16)){
//printf("code=%04x\n",c);
			char	s[2],t[8];
			int32	sl,tl,st;
			s[0]=c>>8;	s[1]=c&255;	sl=2;	tl=8;
			convert_to_utf8(B_UNICODE_CONVERSION,s,&sl,t,&tl,&st);
			be_clipboard->Lock();
			be_clipboard->Clear();
			BMessage	*mes=be_clipboard->Data();
			mes->AddData("text/plain",B_MIME_TYPE,t,tl);
			be_clipboard->Commit();
			be_clipboard->Unlock();
		}
	}
}

void kmapview::MouseMoved(BPoint pt,uint32 code,const BMessage *msg)
{
	static uint16	bc=0xffff;
	uint16	nc=0xffff;
	if((pt.x>cx)&&(pt.y>cy)&&(dat[sel].sc<0xffff)){
		int		x,y;
		x=(pt.x-cx)/cw;	y=(pt.y-cy)/ch;
		uint16	c=(dat[sel].sc&0xfff0)+y*16+x;
		if((c>=dat[sel].sc)&&(c<=dat[sel].ec)&&(x<16))nc=c;
	}
	if(nc!=bc){
		char	s[16];
		if(nc==0xffff)strcpy(s,"");
		else sprintf(s,"unicode : %04x",nc);
		((kmapwindow*)Window())->sv->SetText(s);
		bc=nc;
	}
}

void kmapview::MessageReceived(BMessage *msg)
{
	switch(msg->what){
		case 'font':{
			const char	*ff,*fs;
			int8	fp;
			uchar	f=0;
			if(!msg->FindString("font_family",&ff))f|=1;
			if(!msg->FindString("font_style",&fs))f|=2;;
			if(!msg->FindInt8("font_size",&fp))f|=4;
			if((f&3)==3){
				cf.SetFamilyAndStyle(ff,fs);
				mf.SetFamilyAndStyle(ff,fs);		//menu
			}
			if(f&4)cf.SetSize(cp=fp);
			Invalidate();
		}break;
		default:{
			BView::MessageReceived(msg);
		}break;
	}
}
